package com.steerinfo.baseinfo.meterbaseunitinfo.controller;

import com.steerinfo.baseinfo.meterbaseunitinfo.model.MeterBaseUnitInfo;
import com.steerinfo.baseinfo.meterbaseunitinfo.service.IMeterBaseUnitInfoService;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterBaseUnitInfo RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-04-12 10:02
 * 类描述
 * 修订历史：
 * 日期：2022-04-12
 * 作者：generator
 * 参考：
 * 描述：MeterBaseUnitInfo RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterbaseunitinfos")
public class MeterBaseUnitInfoController extends BaseRESTfulController {

    @Autowired
    IMeterBaseUnitInfoService meterBaseUnitInfoService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbaseunitinfo:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseUnitInfo> list = meterBaseUnitInfoService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbaseunitinfo:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseUnitInfo> list = meterBaseUnitInfoService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据MeterBaseUnitInfo对象创建")
    @ApiImplicitParam(name = "meterBaseUnitInfo", value = "详细实体meterBaseUnitInfo", required = true, dataType = "MeterBaseUnitInfo")
    //@RequiresPermissions("meterbaseunitinfo:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody MeterBaseUnitInfo model){
        MeterBaseUnitInfo meterBaseUnitInfo = meterBaseUnitInfoService.add(model);
        return success(meterBaseUnitInfo);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbaseunitinfo:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterBaseUnitInfo meterBaseUnitInfo = meterBaseUnitInfoService.getById(id);
        return success(meterBaseUnitInfo);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterBaseUnitInfo信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterBaseUnitInfo", value = "详细实体meterBaseUnitInfo", required = true, dataType = "MeterBaseUnitInfo")
    })
    //@RequiresPermissions("meterbaseunitinfo:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseUnitInfo model){
        model.setId(id);
        MeterBaseUnitInfo meterBaseUnitInfo = meterBaseUnitInfoService.modify(model);
        return success(meterBaseUnitInfo);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbaseunitinfo:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterBaseUnitInfoService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value="获取不分页列表", notes="不分页模糊查询")
    @GetMapping(value = "/noPage/")
    public RESTfulResult queryBynoPage(@RequestParam HashMap parmas){
        List<MeterBaseUnitInfo> list = meterBaseUnitInfoService.queryBynoPage(parmas);
        return success(list);
    }

    @ApiOperation(value="创建", notes="根据MeterBaseUnitInfo对象创建")
    @ApiImplicitParam(name = "meterBaseUnitInfo", value = "详细实体meterBaseUnitInfo", required = true, dataType = "MeterBaseUnitInfo")
    @PostMapping(value = "/addModel")
    public RESTfulResult addModel(@RequestBody MeterBaseUnitInfo model){
        RESTfulResult rm = meterBaseUnitInfoService.addModel(model);
        return rm;
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @PostMapping(value = "/delModel")//String
    public RESTfulResult delModel(@RequestBody List<MeterBaseUnitInfo> models){
        List<String> list = new ArrayList<>();
        for(MeterBaseUnitInfo model: models) {
            list.add(model.getUnitNo());
        }
        if(ListUtils.isNotEmpty(list)) {
            List<String> ids = ListUtils.convertList(list);
            meterBaseUnitInfoService.delete(ids);
        }
        return success(null,"删除成功");
    }

    @ApiOperation(value="获取不分页列表", notes="不分页模糊查询")
    @PostMapping(value = "/getUnitInfo")
    public RESTfulResult getUnitInfo(@RequestBody MeterBaseUnitInfo parmas){
        List<MeterBaseUnitInfo> list = meterBaseUnitInfoService.getUnitInfo(parmas);
        return success(list);
    }
}
